require 'slop'
require 'json'

module Crabbs
  class CLI

    def start
      begin
        opts = parse_options
        result = Crabbs.start({ url: opts[:url], verbose: opts[:verbose] })
        STDOUT.puts "\nResult:\n#{result.to_json}"
      rescue Slop::MissingOptionError => e
        STDOUT.puts e.message
      end
    end

    private

    def parse_options
      Slop.parse(help: true) do
        banner 'Usage: crabbs [options]'

        on 'u', 'url=', 'URL to start crawling', required: true
        on 'v', 'verbose', 'Shows URLs being crawled', default: false
      end
    end
  end
end
