module Crabbs
  class Link

    def initialize(href)
      @href = href
      @uri = URI.parse(href)
    end

    def same_host_as?(url)
      @uri.host == URI.parse(url).host or @uri.host.nil?
    end

    def has_valid_fragment?
      @uri.fragment.nil? or not @uri.fragment.empty?
    end

    def has_html_extension?
      link = @href
      if not @uri.host.nil?
        link = @href.sub(@uri.host, '')
      end

      extension = File.extname(link)
      extension.empty? or extension == '.html'
    end

    def join(url)
      new_uri = @uri

      if @uri.host.nil?
        new_uri = URI.parse url
        new_uri = URI.join(new_uri.to_s, @uri.path) unless @uri.path.nil?
        new_uri = URI.join(new_uri.to_s, "?#{@uri.query}") unless @uri.query.nil?
        new_uri = URI.join(new_uri.to_s, "##{@uri.fragment}") unless @uri.fragment.nil?
      end

      new_uri.to_s
    end
  end
end
