require 'nokogiri'
require 'crabbs/link'

module Crabbs
  class Page
    def initialize(html, url)
      @html = Nokogiri::HTML(html)
      @url = url
    end

    def links
      links = @html.css('a[href]').map { |a| Crabbs::Link.new a['href'] }

      links
        .select { |link| link.same_host_as? @url }
        .select(&:has_valid_fragment?)
        .select(&:has_html_extension?)
        .map { |link| link.join @url }
        .uniq
    end
  end
end
